\name{BVAR_linear}
\alias{BVAR_linear}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Bayesian VAR
%%  ~~function to do ... ~~
}
\description{
This is the sub function that estimates the country VAR models. It is directly called from \code{gvar.ssvs}.
}
\usage{
BVAR_linear(nr, gW = gW, xglobal = xglobal, cN, p = 4, nsave = 500, nburn = 500, hyper = list(c_tau = 0.01, d_tau = 0.01, e_lambda = 1.5, d_lambda = 1,  prmean = 0, a_start = 0.6, sample_A = TRUE), prior = "NG", thin = 0.1, sv = TRUE, trend = FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{nr}{ Is a selector referring to the number of the country model to be estimated (same order as in \code{cN} below).
}
  \item{gW}{
 Is a list object of length N containing the country-specific weight matrices.
}
  \item{xglobal}{is a matrix object of dimension T times N (T # of observations, K # of variables in the system).
}
  \item{cN}{ Character vector of the country names.}
  \item{p}{ Number of lags used (the same for domestic, exogenous and weakly exogenous variables).}
  \item{nsave}{ Number of draws saved.}
  \item{nburn}{ Number of burn-ins.}
  \item{hyper}{ Is a list object that defines the hyperparameters of the chosen prior. See \code{bgvar} for further details.}
  \item{prior}{ Either "SSVS",  "SIMS" or "NG". See the description for \code{gvar.ssvs}.}
  \item{thin}{ Is a thinning interval which grabs save_thin percent of your posterior output. As a rule of thumb, workspaces get large if save_thin*saves>500.}
  \item{sv}{ Set to \code{TRUE} implying use of stochastic volatility.}
  \item{trend}{ Set to \code{TRUE} if a trend should be included. Currently de-funct.}
}

\references{
Part of the algorithm is based on Koop and Korobilis.
}
\author{
Florian Huber
}

\seealso{
See also  \code{\link{bgvar}}.
}

