\name{forecast}
\alias{fcast}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Compute forecasts
}
\description{
A function that computes forecasts based on a GVAR object.}
\usage{
fcast(gvar.obj,h=0,fhorz=8)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{gvar.obj}{ An objected fitted by function \code{bgvar}.}
  \item{h}{ For out-of-sample forecasts, set \code{h} to zero, otherwise the function will cut \code{h} observations from the sample which can be used later on to evaluate the forecast accuracy in a pseudo-out-of-sample exercise.}
  \item{fhorz}{ The forecast horizon.}
}
\details{
%%  ~~ If necessary, more details than the description above ~~
}
\value{\itemize{
\item{\code{fcast}}{ is a K times \code{fhorz} times 5 -dimensional array that contains the 16\%th, 25\%th, 50\%th, 75\%th and 84\% percentiles of the posterior predictive distribution.}
\item{\code{xlgobal}}{ is a matrix object of dimension T times N (T # of observations, K # of variables in the system).}
\item{\code{fhorz}}{ is the specified forecast horizon.}
}

}
\references{
%% ~put references to the literature/web site here ~
}
\author{
Martin Feldkircher and Florian Huber
}
\note{
%%  ~~further notes~~
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
}
\examples{
library(BGVAR)
data(eerData)
model.sims<-bgvar(Data=eer.data,W=W.trade0012,saves=100,burns=100,plag=1,Cpu=4,prior="SIMS",save_thin=1,eigen=TRUE,logfile=FALSE,stats=TRUE)

fcastM<-fcast(model.sims,h=0,fhorz=8)

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
