\name{irf.plot}
\alias{irf.plot}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Function to plot impulse responses
}
\description{
A function that plot median responses along with 25-75\% and 16-84\% credible sets.
}
\usage{
irf.plot(irf.obj, resp, shock.nr = 1, B = NULL, N = 8, Main =NULL, cex.la = 1.2, cum = FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{irf.obj}{ An objected generated by function \code{IRF}.}
  \item{resp}{ The name of the response variable that should be plotted. If only the country name is specified, \code{irf.plot} automatically plots impulses for all responses of that country.}
  \item{shock.nr}{ The number of the identified shock for which impulse responses should be drawn. Default is 1 for the first shock.}
  \item{B}{ The range of the plot. Default is \code{NULL} in which the range is automatically set.}
  \item{N}{ The number of axis ticks with labels.}
  \item{Main}{ A title. If set to \code{NULL}, names of the underlying data in the \code{irf.obj} are used.}
  \item{cex.la}{ The size of the axis label.}
  \item{cum}{ If \code{TRUE}, cumulative responses are computed.}
}
\details{
%%  ~~ If necessary, more details than the description above ~~
}
\value{
%%  ~Describe the value returned
%%  If it is a LIST, use
%%  \item{comp1 }{Description of 'comp1'}
%%  \item{comp2 }{Description of 'comp2'}
%% ...
}
\references{
%% ~put references to the literature/web site here ~
}
\author{
Martin Feldkircher
}
\note{
%%  ~~further notes~~
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
}
\examples{
 library(BGVAR)
  data(monthlyData)
  # estimates the model
  model.ssvs<-bgvar(Data=new.data,W=W,saves=100,burns=100,plag=1,Cpu=1,prior="SSVS",save_thin=1,eigen=TRUE,trim=1.05)

  EA_countries <- c("AT", "BE", "DE","ES", "FI","FR", "IE", "IT", "NL", "PT","GR","SK") #,"MT","CY","EE","LT","LV")

  # A simultaneous cholesky shock to long-term interest rates in the euro area countries, scaled to amount to -100 basis points (on average over the EA countries).
  # Note that the ordering of the variables influences the response, the ordering is exactly as in the country models, to use a different order you have re-estimate
  # the model (by gvar.ssvs)
  shocks<-list();shocks$shock="ltir";shocks$ccode<-EA_countries;shocks$ident="chol"
  irf.chol<-IRF(gvar.obj=model.ssvs,shockc=shocks,nhor=48)

  # Plots a specific variable (i.e., "DE.y")
  irf.plot(irf.chol, resp="DE.y",Main="Industrial Production (DE)")

  # Plots all variables of a given country
  irf.plot(irf.chol, resp="AT")
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
