\name{lps}
\alias{lps}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Log predictive scores (LPS)
}
\description{
Calculates log predictive scores using the normal distribution as approximation for the predictive density. The function calculates LPS for the marginal densities and not for the joint predictive distribution (of all variables in the GVAR system). If the forecast horizon is greater than 1 (\code{fhorz} in \code{fcast}), LPS is the sum of single LPS over the forecast horizon per variable.
}
\usage{
lps(fcastM)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{fcastM}{ An object fitted using \code{fcast}. Make sure that you have set \code{h>0} in \code{fcast}. }
}
\details{
%%  ~~ If necessary, more details than the description above ~~
}
\value{
\item{lps.scores }{A vector that returns the log predictive scores.}
%%  \item{comp2 }{Description of 'comp2'}
%% ...
}

\author{
Martin Feldkircher
}
\note{
%%  ~~further notes~~
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
See also \code{\link{fcast}}
}
\examples{
library(BGVAR)
data(monthlyData)
model.sims<-bgvar(Data=new.data,W=W,saves=100,burns=100,plag=1,hyperparm=NULL,Cpu=1,prior="SIMS",save_thin=1,eigen=TRUE,logfile=FALSE,stats=TRUE)
fcastM<-fcast(model.sims,h=5,fhorz=8)

lps(fcastM)
}
