  # 1 --- Dp.yoy, poil in levels
  rm(list=ls())
  sPath<-"/common1/feldkirc/Global inflation/GVAR"
  setwd(sPath)
  load("global_inflation_gvar.rda")
  library(BGVAR)
  
  # make country VAR list
  
  setwd(sPath)
  
  # make FEVD based weights
  load("/common1/feldkirc/Global inflation/DieboldYilmaz/fevd_p_4_a_0.6_sv_0_prmean_1_infl_exp.rda")
  W.infl.exp<-fevd$fevd_array_girf[,,12,"mean"]
  dimnames(W.infl.exp)[[1]]<-dimnames(W.infl.exp)[[2]]<-substr(rownames(W.infl.exp),1,2)
  W.0012<-new.data$W.0012;new.data$W.0012<-NULL
  cN<-names(new.data);cN<-cN[-charmatch(c("EB","ppp.EA"),cN)]
  # make sure new weight list is in the same order as are the countries
  W.infl.exp<-W.infl.exp[cN,cN];diag(W.infl.exp)<-0 # diag=0 sets own contribution to zero
  #re-scale W.infl.exp in order to sum up to unity
  W.infl.exp<-W.infl.exp/rowSums(W.infl.exp)
  
  # make FEVD based weights
  load("/common1/feldkirc/Global inflation/DieboldYilmaz/fevd_p_4_a_0.6_sv_0_prmean_1_Dp_yoy.rda")
  W.infl<-fevd$fevd_array_girf[,,12,"mean"]
  dimnames(W.infl)[[1]]<-dimnames(W.infl)[[2]]<-substr(rownames(W.infl),1,2)
  # make sure new weight list is in the same order as are the countries
  W.infl<-W.infl[cN,cN];diag(W.infl)<-0 # diag=0 sets own contribution to zero
  #re-scale W.infl.exp in order to sum up to unity
  W.infl<-W.infl/rowSums(W.infl)
  
  
  # make sure data is in same country order as in weight matrix
  cN<-rownames(W.infl.exp)
  new.data<-new.data[c(cN,"EB","ppp.EA")]
  W.0012<-W.0012[cN,cN]
  
  
  # set up weights for ECB country model - interest rates determined by EA inflation (D.t, trend infl) and output (y)
  EA.weights$weights<-new.data$ppp.EA;new.data$ppp.EA<-NULL
  EA_countries<-names(EA.weights$weights)
  EA.weights$variables<-c("gdp.m","Dp.yoy")
  EA.weights$exo<-"EAstir"
  
  
  new.data$OC<-new.data$US[,c("poil","qoil")]
  OC.weights<-list()
  load("ppp_global_inflation.rda")
  OC.weights$weights<-ppp
  OC.weights$variables<-"gdp.m"
  OC.weights$exo<-"poil"
  
  
  # calculate term spread
  for (jj in 1:(length(cN))){
    if(cN[jj]%in%EA_countries){
      new.data[[jj]]<-cbind(new.data[[jj]],c(new.data[[jj]][,"ltir"]-new.data$EB[,"EAstir"]))
    }else{
      new.data[[jj]]<-cbind(new.data[[jj]],c(new.data[[jj]][,"ltir"]-new.data[[jj]][,"stir"]))
    }
    colnames(new.data[[jj]])<-gsub("new.data[[jj]].","",colnames(new.data[[jj]]),fix=TRUE);colnames(new.data[[jj]])[ncol(new.data[[jj]])]<-"sp"
  }
  
  # select variables to be included here - names should not be longer than 4 characters including separators
  for (k in 1:length(cN)){
    if ((cN[k] %in% EA_countries)){
      sl_vars <- c("infl_exp","Dp.yoy","gdp.m","ur","sp","reer")# this is for EA countries (no stir)
    }
    if(!cN[k]%in% EA_countries){
      sl_vars <- c("infl_exp","Dp.yoy","gdp.m","ur","stir","sp","reer")
    }
    if(cN[k]=="US"){
      sl_vars<-c("infl_exp","Dp.yoy","gdp.m","ur","stir","sp","reer") # US includes oil prices 
    }
    
    
    temp <- as.matrix(new.data[[k]])
    
    #NA checking
    check_na <- matrix(sapply(new.data[[k]],is.na),nrow(temp),ncol(temp))
    check_na <- colSums(check_na)
    nakill <- which(check_na>5)
    if (length(nakill)>0){
      temp <- temp[,-nakill]
    }
    temp[is.na(temp)] <- 0
    temp1 <- temp
    tmp_vars <- colnames(temp)
    slct <- intersect(sl_vars,tmp_vars)
    new.data[[k]] <- temp[,slct]
  }
  
  new.data$EB<-new.data$EB[,"EAstir",drop=FALSE]


  rm(list=setdiff(ls(), c("new.data","W.infl","W.infl.exp","W.0012","EA.weights","sPath","OC.weights"))) # delete everything besides these objects
  
  
  
  # first model with infl expectation weights
  # p2_a_0.6_e_3_d_0.03 for Dpyoy it would be p1_a_0.6_e_1.5_d_0.03 but p2 is also ok
  hyperparm<-list(c_tau = 0.01, d_tau = 0.01,e_lambda=1.5,d_lambda=1, prmean=1,a_start=.6,sample_A=FALSE)#standard setting
  hyper<-hyperparm;hyper$a_start=0.6;hyper$e_lambda<-3;hyper$d_lambda<-0.03;hyper$prmean<-0;hyper$a_i=0.01;hyper$b_i=0.01
  model.ng.p2.mixed.ur.dpyoy<-bgvar(new.data,W=W.infl.exp,saves=20000,burns=30000,plag=2,Cpu=length(new.data),prior="NG",hyperparm=hyper,save_thin=0.1,eigen=TRUE,stats=TRUE,logfile=TRUE,trim=1.05,ea.weights=EA.weights,OC.weights=OC.weights)
  
  # diagnostic checks
  model.ng.p2.mixed.ur.dpyoy$stacked.results$trim.info # see how many draws have been stable
  
  # look at serial correlation in residuals, 2 lags should be sufficient
  
  Res<-model.ng.p2.mixed.ur.dpyoy$cc.results$res
  colnames(Res)<-colnames(model.ng.p2.mixed.ur.dpyoy$xglobal)
  pdf("acf_modelng_infl_exp.pdf")
  for(i in 1:ncol(Res)){
    acf(Res[,i],main=paste(colnames(Res)[i]))
  }
  dev.off()
  save(model.ng.p2.mixed.ur.dpyoy,file="model_ng_p2_mixed_ur_dpyoy_oil.rda")
  
  
  
  #----------------------------------------------------------------------------------------------------
  # 2 dp.yoy poil.yoy
  rm(list=ls())
  sPath<-"/common1/feldkirc/Global inflation/GVAR"
  setwd(sPath)
  load("global_inflation_gvar.rda")
  library(BGVAR)
  
  # make country VAR list
  
  setwd(sPath)
  
  # make FEVD based weights
  load("/common1/feldkirc/Global inflation/DieboldYilmaz/fevd_p_4_a_0.6_sv_0_prmean_1_infl_exp.rda")
  W.infl.exp<-fevd$fevd_array_girf[,,12,"mean"]
  dimnames(W.infl.exp)[[1]]<-dimnames(W.infl.exp)[[2]]<-substr(rownames(W.infl.exp),1,2)
  W.0012<-new.data$W.0012;new.data$W.0012<-NULL
  cN<-names(new.data);cN<-cN[-charmatch(c("EB","ppp.EA"),cN)]
  # make sure new weight list is in the same order as are the countries
  W.infl.exp<-W.infl.exp[cN,cN];diag(W.infl.exp)<-0 # diag=0 sets own contribution to zero
  #re-scale W.infl.exp in order to sum up to unity
  W.infl.exp<-W.infl.exp/rowSums(W.infl.exp)
  
  # make FEVD based weights
  load("/common1/feldkirc/Global inflation/DieboldYilmaz/fevd_p_4_a_0.6_sv_0_prmean_1_Dp_yoy.rda")
  W.infl<-fevd$fevd_array_girf[,,12,"mean"]
  dimnames(W.infl)[[1]]<-dimnames(W.infl)[[2]]<-substr(rownames(W.infl),1,2)
  # make sure new weight list is in the same order as are the countries
  W.infl<-W.infl[cN,cN];diag(W.infl)<-0 # diag=0 sets own contribution to zero
  #re-scale W.infl.exp in order to sum up to unity
  W.infl<-W.infl/rowSums(W.infl)
  
  
  
  # make sure data is in same country order as in weight matrix
  cN<-rownames(W.infl.exp)
  new.data<-new.data[c(cN,"EB","ppp.EA")]
  W.0012<-W.0012[cN,cN]
  
  
  # set up weights for ECB country model - interest rates determined by EA inflation (D.t, trend infl) and output (y)
  EA.weights$weights<-new.data$ppp.EA;new.data$ppp.EA<-NULL
  EA_countries<-names(EA.weights$weights)
  EA.weights$variables<-c("gdp.m","Dp.yoy")
  EA.weights$exo<-"EAstir"
  
  
  new.data$OC<-new.data$US[,c("poil.yoy","qoil")]
  OC.weights<-list()
  load("ppp_global_inflation.rda")
  OC.weights$weights<-ppp
  OC.weights$variables<-"gdp.m"
  OC.weights$exo<-"poil.yoy"
  
  
  # calculate term spread
  for (jj in 1:(length(cN))){
    if(cN[jj]%in%EA_countries){
      new.data[[jj]]<-cbind(new.data[[jj]],c(new.data[[jj]][,"ltir"]-new.data$EB[,"EAstir"]))
    }else{
      new.data[[jj]]<-cbind(new.data[[jj]],c(new.data[[jj]][,"ltir"]-new.data[[jj]][,"stir"]))
    }
    colnames(new.data[[jj]])<-gsub("new.data[[jj]].","",colnames(new.data[[jj]]),fix=TRUE);colnames(new.data[[jj]])[ncol(new.data[[jj]])]<-"sp"
  }
  
  # select variables to be included here - names should not be longer than 4 characters including separators
  for (k in 1:length(cN)){
    if ((cN[k] %in% EA_countries)){
      sl_vars <- c("infl_exp","Dp.yoy","gdp.m","ur","sp","reer")# this is for EA countries (no stir)
    }
    if(!cN[k]%in% EA_countries){
      sl_vars <- c("infl_exp","Dp.yoy","gdp.m","ur","stir","sp","reer")
    }
    if(cN[k]=="US"){
      sl_vars<-c("infl_exp","Dp.yoy","gdp.m","ur","stir","sp","reer") # US includes oil prices 
    }
    
    
    temp <- as.matrix(new.data[[k]])
    
    #NA checking
    check_na <- matrix(sapply(new.data[[k]],is.na),nrow(temp),ncol(temp))
    check_na <- colSums(check_na)
    nakill <- which(check_na>5)
    if (length(nakill)>0){
      temp <- temp[,-nakill]
    }
    temp[is.na(temp)] <- 0
    temp1 <- temp
    tmp_vars <- colnames(temp)
    slct <- intersect(sl_vars,tmp_vars)
    new.data[[k]] <- temp[,slct]
  }
  
  new.data$EB<-new.data$EB[,"EAstir",drop=FALSE]
  
  
  rm(list=setdiff(ls(), c("new.data","W.infl","W.infl.exp","W.0012","EA.weights","sPath","OC.weights"))) # delete everything besides these objects
  
  
  
  # first model with infl expectation weights
  # p2_a_0.6_e_3_d_0.03 for Dpyoy it would be p1_a_0.6_e_1.5_d_0.03 but p2 is also ok
  hyperparm<-list(c_tau = 0.01, d_tau = 0.01,e_lambda=1.5,d_lambda=1, prmean=1,a_start=.6,sample_A=FALSE)#standard setting
  hyper<-hyperparm;hyper$a_start=0.6;hyper$e_lambda<-3;hyper$d_lambda<-0.03;hyper$prmean<-0;hyper$a_i=0.01;hyper$b_i=0.01
  model.ng.p2.mixed.ur.dpyoy.poilyoy<-bgvar(new.data,W=W.infl.exp,saves=30000,burns=30000,plag=2,Cpu=length(new.data),prior="NG",hyperparm=hyper,save_thin=0.1,eigen=TRUE,stats=TRUE,logfile=TRUE,trim=1.05,ea.weights=EA.weights,OC.weights=OC.weights)
  
  # diagnostic checks
  model.ng.p2.mixed.ur.dpyoy.poilyoy$stacked.results$trim.info # see how many draws have been stable
  
  # look at serial correlation in residuals, 2 lags should be sufficient
  
  Res<-model.ng.p2.mixed.ur.dpyoy.poilyoy$cc.results$res
  colnames(Res)<-colnames(model.ng.p2.mixed.ur.dpyoy.poilyoy$xglobal)
  pdf("acf_modelng_infl_exp.pdf")
  for(i in 1:ncol(Res)){
    acf(Res[,i],main=paste(colnames(Res)[i]))
  }
  dev.off()
  save(model.ng.p2.mixed.ur.dpyoy.poilyoy,file="model_ng_p2_mixed_ur_dpyoy_poilyoy.rda")
  
  
  # ----------------------------------------------------------------------------------------------------------------
  # 3 dpyoy and poil.yoy and ssr for zero-lower bound countries
  
  rm(list=ls())
  sPath<-"/common1/feldkirc/Global inflation/GVAR"
  setwd(sPath)
  load("global_inflation_gvar.rda")
  library(BGVAR)
  
  # make country VAR list
  
  setwd(sPath)
  
  # make FEVD based weights
  load("/common1/feldkirc/Global inflation/DieboldYilmaz/fevd_p_4_a_0.6_sv_0_prmean_1_infl_exp.rda")
  W.infl.exp<-fevd$fevd_array_girf[,,12,"mean"]
  dimnames(W.infl.exp)[[1]]<-dimnames(W.infl.exp)[[2]]<-substr(rownames(W.infl.exp),1,2)
  W.0012<-new.data$W.0012;new.data$W.0012<-NULL
  cN<-names(new.data);cN<-cN[-charmatch(c("EB","ppp.EA"),cN)]
  # make sure new weight list is in the same order as are the countries
  W.infl.exp<-W.infl.exp[cN,cN];diag(W.infl.exp)<-0 # diag=0 sets own contribution to zero
  #re-scale W.infl.exp in order to sum up to unity
  W.infl.exp<-W.infl.exp/rowSums(W.infl.exp)
  
  # make FEVD based weights
  load("/common1/feldkirc/Global inflation/DieboldYilmaz/fevd_p_4_a_0.6_sv_0_prmean_1_Dp_yoy.rda")
  W.infl<-fevd$fevd_array_girf[,,12,"mean"]
  dimnames(W.infl)[[1]]<-dimnames(W.infl)[[2]]<-substr(rownames(W.infl),1,2)
  # make sure new weight list is in the same order as are the countries
  W.infl<-W.infl[cN,cN];diag(W.infl)<-0 # diag=0 sets own contribution to zero
  #re-scale W.infl.exp in order to sum up to unity
  W.infl<-W.infl/rowSums(W.infl)
  
  
  
  # make sure data is in same country order as in weight matrix
  cN<-rownames(W.infl.exp)
  new.data<-new.data[c(cN,"EB","ppp.EA")]
  W.0012<-W.0012[cN,cN]
  
  
  # set up weights for ECB country model - interest rates determined by EA inflation (D.t, trend infl) and output (y)
  EA.weights$weights<-new.data$ppp.EA;new.data$ppp.EA<-NULL
  EA_countries<-names(EA.weights$weights)
  EA.weights$variables<-c("gdp.m","Dp.yoy")
  EA.weights$exo<-"EAstir"
  
  
  new.data$OC<-new.data$US[,c("poil.yoy","qoil")]
  OC.weights<-list()
  load("ppp_global_inflation.rda")
  OC.weights$weights<-ppp
  OC.weights$variables<-"gdp.m"
  OC.weights$exo<-"poil.yoy"
  
  
  # calculate term spread
  for (jj in 1:(length(cN))){
    if(cN[jj]%in%EA_countries){
      new.data[[jj]]<-cbind(new.data[[jj]],c(new.data[[jj]][,"ltir"]-new.data$EB[,"EAstir"]))
    }else{
      new.data[[jj]]<-cbind(new.data[[jj]],c(new.data[[jj]][,"ltir"]-new.data[[jj]][,"stir"]))
    }
    colnames(new.data[[jj]])<-gsub("new.data[[jj]].","",colnames(new.data[[jj]]),fix=TRUE);colnames(new.data[[jj]])[ncol(new.data[[jj]])]<-"sp"
  }
  
  
   
  # use shadow rates instead of short-term interest rates for countries with zero lower bound
  load("krippner_full.rda")# 2001:01 to 2016:12
  
  new.data$US[,"stir"]<-window(krippner.full[,"US"],start=c(2001,1),end=c(2016,12))
  new.data$GB[,"stir"]<-window(krippner.full[,"GB"],start=c(2001,1),end=c(2016,12))
  new.data$JP[,"stir"]<-window(krippner.full[,"JP"],start=c(2001,1),end=c(2016,12))
  new.data$EB[,"EAstir"]<--window(krippner.full[,"EA"],start=c(2001,1),end=c(2016,12))
  
  
  
  # select variables to be included here - names should not be longer than 4 characters including separators
  for (k in 1:length(cN)){
    if ((cN[k] %in% EA_countries)){
      sl_vars <- c("infl_exp","Dp.yoy","gdp.m","ur","sp","reer")# this is for EA countries (no stir)
    }
    if(!cN[k]%in% EA_countries){
      sl_vars <- c("infl_exp","Dp.yoy","gdp.m","ur","stir","sp","reer")
    }
    if(cN[k]=="US"){
      sl_vars<-c("infl_exp","Dp.yoy","gdp.m","ur","stir","sp","reer") # US includes oil prices 
    }
    
    
    temp <- as.matrix(new.data[[k]])
    
    #NA checking
    check_na <- matrix(sapply(new.data[[k]],is.na),nrow(temp),ncol(temp))
    check_na <- colSums(check_na)
    nakill <- which(check_na>5)
    if (length(nakill)>0){
      temp <- temp[,-nakill]
    }
    temp[is.na(temp)] <- 0
    temp1 <- temp
    tmp_vars <- colnames(temp)
    slct <- intersect(sl_vars,tmp_vars)
    new.data[[k]] <- temp[,slct]
  }
  
  new.data$EB<-new.data$EB[,"EAstir",drop=FALSE]
  
  
  rm(list=setdiff(ls(), c("new.data","W.infl","W.infl.exp","W.0012","EA.weights","sPath","OC.weights"))) # delete everything besides these objects
  
  
  
  # first model with infl expectation weights
  # p2_a_0.6_e_3_d_0.03 for Dpyoy it would be p1_a_0.6_e_1.5_d_0.03 but p2 is also ok
  hyperparm<-list(c_tau = 0.01, d_tau = 0.01,e_lambda=1.5,d_lambda=1, prmean=1,a_start=.6,sample_A=FALSE)#standard setting
  hyper<-hyperparm;hyper$a_start=0.6;hyper$e_lambda<-3;hyper$d_lambda<-0.03;hyper$prmean<-0;hyper$a_i=0.01;hyper$b_i=0.01
  model.ng.p2.mixed.ur.dpyoy.poilyoy.ssr<-bgvar(new.data,W=W.infl.exp,saves=30000,burns=30000,plag=2,Cpu=length(new.data),prior="NG",hyperparm=hyper,save_thin=0.1,eigen=TRUE,stats=TRUE,logfile=TRUE,trim=1.05,ea.weights=EA.weights,OC.weights=OC.weights)
  
  # diagnostic checks
  model.ng.p2.mixed.ur.dpyoy.poilyoy.ssr$stacked.results$trim.info # see how many draws have been stable
  
  # look at serial correlation in residuals, 2 lags should be sufficient
  
  Res<-model.ng.p2.mixed.ur.dpyoy.poilyoy.ssr$cc.results$res
  colnames(Res)<-colnames(model.ng.p2.mixed.ur.dpyoy.poilyoy.ssr$xglobal)
  pdf("acf_modelng_infl_exp.pdf")
  for(i in 1:ncol(Res)){
    acf(Res[,i],main=paste(colnames(Res)[i]))
  }
  dev.off()
  save(model.ng.p2.mixed.ur.dpyoy.poilyoy.ssr,file="model_ng_p2_mixed_ur_dpyoy_poilyoy_ssr.rda")
  
  
  

